require 'rubygems'
require 'bundler/setup'

require 'spimaging'
require 'test_server'

require 'tempfile'
require 'yaml'

RSpec.configure do |config|
  config.add_setting :server
  config.add_setting :spimaging_configuration

  config.server = SPImaging::TestServer.new
  config.server.start

  config.include SPImaging::TestServerHelper

  config.before :suite do
    ENV['RACK_ENV'] = 'test'
    ENV['RAILS_ENV'] = 'test'

    yml = Tempfile.new(['spimaging-config', '.yml'])
    template = YAML.load_file File.join(File.dirname(__FILE__), 'config.yml')
    template['test'].merge!('base_url' => config.server.base_url)
    yml.write YAML.dump(template)
    yml.close

    # yml = Tempfile.new(['spimaging-config', '.yml'])
    # template = YAML.load_file File.join(File.dirname(__FILE__), 'config.yml')
    # template['test'].merge!('base_url' => "http://localhost:8081/spimaging/", 'username' => 'secret', 'password' => 'secret')
    # yml.write YAML.dump(template)
    # yml.close

    config.spimaging_configuration = yml
    SPImaging::Configuration.configuration_file = yml.path
  end

  config.after :suite do
    config.spimaging_configuration.unlink
  end
end
