require 'net/http'
require 'rack'
require 'rack/handler/thin'

module SPImaging
  class TestServer
    attr_accessor :env, :response

    def initialize
      @host = '127.0.0.1'
      @port = find_available_port
    end

    def base_url
      "http://#{@host}:#{@port}"
    end

    def url(path)
      URI.join(base_url, path).to_s
    end

    def call(env)
      self.env = env
      response.tap{self.response = nil}
    end

    def start
      @thread = Thread.new do
        Rack::Handler::Thin.run self, :Host => @host, :Port => @port do |server|
          @server = server
        end
      end
      sleep(0.1) until @server and @server.running?
    end

    private

    # Stolen from Capybara
    def find_available_port
      server = TCPServer.new(@host, 0)
      server.addr[1]
    ensure
      server.close if server
    end
  end

  module TestServerHelper
    def server
      RSpec.configuration.server
    end
  end
end
